module PUBMED.ServantClientLogging where

import qualified Data.Binary.Builder as DBB
import Debug.Trace (trace)
import Servant.Client (ClientEnv(..))
import Servant.Client.Core.Request (RequestF(..))


addLoggingToClientEnv :: ClientEnv -> ClientEnv
addLoggingToClientEnv env@(ClientEnv { makeClientRequest = mcr }) = env { makeClientRequest }
  where
    makeClientRequest baseUrl req =
      trace ("req: " <> showRequestPath req <> " " <> show (requestQueryString req)) $ mcr baseUrl req
    showRequestPath req =
      show $ DBB.toLazyByteString $ requestPath req
