module PUBMED.Types where

import Control.Monad.Reader (ReaderT)
import Data.Text (Text)


type APIKey = Text
type Offset = Integer
type Query = Text
type PerPage = Integer
type WebEnv = Text

data Config = Config {
    apiKey  :: Maybe APIKey
  , query   :: Query
  , perPage :: Maybe PerPage
  , mWebEnv :: Maybe WebEnv
  }

type Env = ReaderT Config IO


-- | This is the default `retmax` value in ESearch.
defaultPerPage :: PerPage
defaultPerPage = 20
